<?php
function PN_Plugins_Setting_Manager()
{
	global $database, $owner, $defaultURL, $pluginURL, $blogURL, $pluginMenuURL, $adminSkinSetting,$service;
	requireComponent('Eolin.PHP.Core');
	requireComponent('Tattertools.Function.misc');
	requireComponent('Tattertools.Core.BackwardCompatibility');
	$backup=null;
	if(file_exists(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml.gz")){
		$backup=filemtime(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml.gz");
		$backupURL=$defaultURL."/cache/backup/{$owner}_plugins_set_backup.xml.gz";
	}elseif(file_exists(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml")){
		$backup=filemtime(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml");
		$backupURL=$defaultURL."/cache/backup/{$owner}_plugins_set_backup.xml";
	}

	?>
	<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $service['path'].$adminSkinSetting['skin'];?>/basic.css" />
	<link rel="stylesheet" type="text/css" media="screen" href="<?php echo $service['path'].$adminSkinSetting['skin'];?>/setting.css" />
	<?php
	if(isset($checkFunction))
		unset($checkFunction);?>
		<script type="text/javascript">
			//<![CDATA[
				function checkForceTattertoolsVersion() {
					if (confirm("<?php echo _t('需要TT系统检查，现在能否进行？');?>"))
						window.location.href = "<?php echo $blogURL;?>/checkup";
					else
						alert("<?php echo _t('没有检查，用不了该功能.');?>");
				}
			//]]>
		</script>
	<?php
	if(!file_exists(ROOT.'/cache/CHECKUP')){?>
		<script type="text/javascript">
			//<![CDATA[
				window.addEventListener("load", checkTattertoolsVersion, false);
				function checkTattertoolsVersion() {
					if (confirm("<?php echo _t('创建检查升级文件，现在要创建吗？');?>"))
						window.location.href = "<?php echo $blogURL;?>/checkup";
				}
			//]]>
		</script>
	<?php
		$checkFunction='checkForceTattertoolsVersion();';
	}elseif(file_get_contents(ROOT.'/cache/CHECKUP')!=TATTERTOOLS_VERSION){?>
		<script type="text/javascript">
			//<![CDATA[
				window.addEventListener("load", checkTattertoolsVersion, false);
				function checkTattertoolsVersion() {
					if (confirm("<?php echo _t('需要TT系统检查，现在能否进行？');?>"))
						window.location.href = "<?php echo $blogURL;?>/checkup";
				}
			//]]>
		</script>
	<?php
		$checkFunction='checkForceTattertoolsVersion();';
	}

	if(false) 
		forceCheckBlog('');?>
							<script type="text/javascript">
								//<![CDATA[
									var dialog = null;
									
									function showDialog($name) {
										if (dialog)
											dialog.style.display = "none";
										dialog = document.getElementById($name + "Dialog");
										PM.showPanel(dialog);
									}
									
									function hideDialog() {
										if (dialog) {
											dialog.style.display = "none";
											dialog = null;
										}
									}
									
									function backupData() {
										var request = new HTTPRequest("POST", "<?php echo $blogURL;?>/plugin/PluginServerBackup/");
										PM.addRequest(request, "<?php echo _t('正在保存备份文件.');?>");
										request.onSuccess = function () {
											PM.removeRequest(this);
											PM.showMessage("<?php echo _t('备份文件保存成功了.');?>", "center", "bottom");
										}
										request.onError = function () {
											var dd = this.getText();
											PM.removeRequest(this);
											alert("<?php echo _t('备份文件无法保存.');?>");
										}
										request.send();
										hideDialog();
									}
									
									function exportData() {
										window.location.href = "<?php echo $blogURL;?>/plugin/PluginExportBackup/";
										hideDialog();
									}

									function downloadBackup() {
										window.location.href = "<?php echo $blogURL;?>/plugin/PluginDownloadBackup/";
										hideDialog();
									}								

									function importData() {
										var dataImporter = document.getElementById("dataImporter");
										if (document.getElementById("importFromUploaded").checked) {
											if (!dataImporter.elements["backupPath"].value) {
												alert("<?php echo _t('选择备份文件.');?>");
												dataImporter.elements["backupPath"].focus();
												return false;
											}
											document.getElementById("progressText").innerHTML = "<?php echo _t('正在上传备份文件.');?>";
										} else if (document.getElementById("importFromWeb").checked) {
											if (!dataImporter.elements["backupURL"].value) {
												alert("<?php echo _t('输入备份文件的URL.');?>");
												dataImporter.elements["backupURL"].focus();
												return false;
											}
											document.getElementById("progressText").innerHTML = "<?php echo _t('正在拿来备份文件.');?>";
										} else {
											document.getElementById("progressText").innerHTML = "";
										}
										hideDialog();
										document.getElementById("progressIndicator").style.width = "0%";
										document.getElementById("progressDialogTitle").innerHTML = '<?php echo _t('正在复原插件设定数据，请您稍微等一下.');?>';
										document.getElementById("progressText").innerHTML = '<?php echo _t('正在上传备份文件.');?>';
										PM.showPanel("progressDialog");
										dataImporter.submit();
									}
									
									function removeData() {
										var confirmativePassword = document.getElementById("confirmativePassword");
										if (confirmativePassword.value.length < 6) {
											alert("<?php echo _t('要输入密码.');?>");
											confirmativePassword.focus();
											return false;
										}
										var request = new HTTPRequest("POST", "<?php echo $blogURL;?>/plugin/PluginRemove/");
										PM.addRequest(request, "<?php echo _t('正在删除插件设定数据.');?>");
										request.onSuccess = function () {
											PM.removeRequest(this);
											PM.showMessage("<?php echo _t('成功删除插件设定数据.');?>", "center", "bottom");
											confirmativePassword.value = '';
										}
										request.onError = function () {
											PM.removeRequest(this);
											alert("<?php echo _t('密码不对.');?>");
										}
										request.send("confirmativePassword=" + encodeURIComponent(confirmativePassword.value));
										hideDialog();
									}
								//]]>
							</script>
						<div id="plugin-setting-manager">
							<h2 class="caption"><span class="main-text">管理TT插件的备份和复原.</span></h2>
							<div class="pcaption">
							<?php
	echo _t('管理博客插件设定的复原和备份。备份针对<b>\'使用中\'</b>的插件。各个插件的设定可以复原和备份。只限于TT 1.1以上。');?>
							</div>
							<div id="part-data-restore" class="part">
								<h2 class="caption"><span class="main-text"><?php
	echo _t('复原插件设定数据');?></span></h2>
								
								<div class="data-inbox main-explain-box">
									<div class="image" onclick="<?php
	echo forceCheckBlog("showDialog('DBImport');");?> return false">
										<img src="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/image/dbImport.gif" alt="<?php
	echo _t('插件设定数据复原图安');?>" />
										<div class="title"><?php
	echo _t('IMPORT');?></div>
									</div>
									<p class="explain">
										<?php
	echo _t('读取备份文件<br />还原数据.若备份文件中包含附件,将自动还原附件.转移数据也可以通过还原数据来实现.');?>
									</p>
								</div>

								<div id="DBImportDialog" class="dialog" style="position: absolute; display: none; z-index: 100;">
									<form id="dataImporter" method="post" action="<?php
	echo $pluginURL;?>/import" enctype="multipart/form-data" target="blackhole">
										<input type="hidden" name="tempowner" value="<?php echo $owner;?>" />
										<h3><?php
	echo _t('开始插件设定数据的复原');?></h3>
										
										<div class="message-body">
											<div class="explain">
												<?php
	echo _f('此空间允许的最大上传容量为 <em>%1</em> 若超过此大小请用 FTP 等工具上传到其他空间，按照地址进行复原. 考虑安全因素建议复原完成后务必删除文件. ',(getNumericValuePlugin(ini_get('post_max_size'))<getNumericValuePlugin(ini_get('upload_max_filesize'))?ini_get('post_max_size'):ini_get('upload_max_filesize')));?>
											</div>
	<?php
	if($backup){?>
											<p class="message">
												<?php
		echo _f('在服务器的<font color="blue"><em>%1</em></font>上有保存的插件设定备份文件.',Timestamp::format5($backup));?><br />
												<?php
		echo _t('(在服务器上保存的备份文件 <a href="#" onclick="downloadBackup();"><font color="#C56D54">开始下载</font></a>)');?>
											</p>
	<?php
	}?>
											<div class="selection">
	<?php
	if($backup){?>
												<div id="select-server" title="<?php
		echo _t('通过在服务器的插件设定数据备份文件，复原数据。参考上边的数据文件情报.');?>"><input type="radio" id="importFromServer" class="radio" name="importFrom" value="server" checked="checked" onclick="if (this.checked) {hideLayer('uploadBackup'); hideLayer('remoteBackup'); document.getElementById('backupPath').disabled = true; document.getElementById('backupURL').disabled = true;}" /><label for="importFromServer"><?php
		echo _t('在服务器上保存的备份文件.');?></label></div>
	<?php
	}?>
												<div id="select-upload" title="<?php
	echo _t('上传备份文件来复原数据,请注意文件大小不要超过空间允许的最大限制.');?>"><input type="radio" id="importFromUploaded" class="radio" name="importFrom" value="uploaded"<?php
	echo ($backup?'':' checked="checked"');?> onclick="if (this.checked) {showLayer('uploadBackup'); hideLayer('remoteBackup'); document.getElementById('backupPath').disabled = false; document.getElementById('backupURL').disabled = true;}" /><label for="importFromUploaded"><?php
	echo _t('上传备份文件.');?></label></div>
												<div id="select-web" title="<?php
	echo _t('若超过此大小请用 FTP 等工具上传到其他空间，按照地址进行复原. 考虑安全因素建议复原完成后务必删除文件.');?>"><input type="radio" id="importFromWeb" class="radio" name="importFrom" value="web" onclick="if (this.checked) {hideLayer('uploadBackup'); showLayer('remoteBackup'); document.getElementById('backupPath').disabled = true; document.getElementById('backupURL').disabled = false;}" /><label for="importFromWeb"><?php
	echo _t('从网络上读取备份文件.');?></label></div>
												<div id="select-correct" title="<?php
	echo _t('备份文件中若包含不正常字符时复原将失败，可以矫正不正常字符来还原数据.如果使用复原将多需要点时间.');?>"><input type="checkbox" id="correctData" class="checkbox" name="correctData" value="on" /><label for="correctData"><?php
	echo _t('纠正备份文件中的不正常字符.');?></label></div>
											</div>
											<div id="uploadBackup" style="display: <?php
	echo ($backup?'none':'block');?>;">
												<label for="backupPath"><?php
	echo _t('备份文件的路径');?></label><span class="divider"> : </span><input type="file" id="backupPath" class="input-file" name="backupPath" <?php
	echo ($backup?'disabled="disabled"':'');?> />
											</div>
											<div id="remoteBackup" style="display: none;">
												<label for="backupURL"><?php
	echo _t('备份文件 <acronym title="Uniform Resource Locator">URL</acronym>');?></label><span class="divider"> : </span><input type="text" id="backupURL" class="input-text" name="backupURL" value="http://" disabled="disabled" onkeydown="if (event.keyCode == 13) { importData(); return false; }" />
											</div>
										</div>
										<div class="button-box">
											<a class="restore-button button" href="#void" onclick="importData()"><span class="text"><?php
	echo _t('复原');?></span></a>
											<span class="hidden">|</span>
											<a class="close-button button" href="#void" onclick="hideDialog()" title="<?php
	echo _t('取消命令而关掉此窗口.');?>"><span class="text"><?php
	echo _t('取消');?></span></a>
										</div>
									</form>
								</div>
								
								<div id="progressDialog" class="system-dialog" style="position: absolute; display: none; z-index: 100;">
									<h3 id="progressDialogTitle"></h3>
									<div class="message-sub">
										<p id="progressText"></p>
										<p id="progressTextSub"></p>
									</div>
									<div id="progressIndicator" class="progressBar" style="width: 10%; height: 18px; margin-top: 5px; background-color:#66DDFF;"></div>
								</div>
							</div>
							
							<hr class="hidden" />

							<div id="part-data-backup" class="part">
								<h2 class="caption"><span class="main-text"><?php
	echo _t('备份插件设定数据');?></span></h2>
								
								<div class="data-inbox main-explain-box">
									<div class="image" onclick="showDialog('DBExport')">
										<img src="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/image/dbExport.gif" alt="<?php
	echo _t('插件设定数据的备份图案');?>" />
										<div class="title"><?php
	echo _t('EXPORT');?></div>
									</div>
									<p class="explain">
										<?php
	echo _t('把插件设定数据保存为备份文件格式.备份文件可以包含附件, 还原时会自动还原附件.备份文件可以保存在服务器上,也可以下载到本地. .');?>
									</p>
								</div>
								
								<form id="DBExportDialog" class="dialog" method="get" action="<?php
	echo $blogURL;?>/owner/data/backup" style="position: absolute; display: none; z-index: 100;">
									<h3><?php
	echo _t('开始备份插件设定数据');?></h3>
									
									<div class="message-body">
										<p class="message">
											<span><?php echo _t('请你选择保存在服务器或者下载.');?></span><br>
											<span><?php echo _t('(保存在服务器的 <b>\''.$service['path'].'/cache/backup/'.$owner.'_plugins_set_backup.xml\'</b> 里.)');?></span>
										</p>
									</div>
									<div class="button-box">
										<a class="server-button button" href="#void" onclick="backupData()" title="<?php
	echo _t('可以把数据文件保存在服务器上，用做数据还原..');?>"><span class="text"><?php
	echo _t('保存到服务器');?></span></a>
										<span class="hidden">|</span>
										<a class="local-button button" href="#void" onclick="exportData()" title="<?php
	echo _t('备份并下载现在的数据，服务器上的备份数据文件将不做更新');?>"><span class="text"><?php
	echo _t('下载');?></span></a>
										<span class="hidden">|</span>
										<a class="close-button button" href="#void" onclick="hideDialog()" title="<?php
	echo _t('取消命令而关掉此窗口.');?>"><span class="text"><?php
	echo _t('取消');?></span></a>
									</div>
								</form>
							</div>						

							<hr class="hidden" />
							
							<div id="part-data-remove" class="part">
								<h2 class="caption"><span class="main-text"><?php
	echo _t('<font color="#CC1111">删除现在的插件设定数据</font>');?></span></h2>
								
								<div class="data-inbox main-explain-box">
									<div class="image" onclick="showDialog('DBRemove')">
										<img src="<?php
	echo $service['path'].$adminSkinSetting['skin'];?>/image/dbClear.gif" alt="<?php
	echo _t('删除数据图案');?>" />
										<div class="title"><?php
	echo _t('REMOVE');?></div>
									</div>
									<p class="explain">
										<?php
	echo _t('删除插件设定数据.可以选择不删除附件.数据还原只能用备份文件进行还原,所以请先备份. .');?>
									</p>
								</div>
								
								<form id="DBRemoveDialog" class="dialog" method="get" action="<?php
	echo $pluginURL;?>/remove" style="position: absolute; display: none; z-index: 100;">
									<h3><?php
	echo _t('开始删除插件设定数据');?></h3>
									
									<div class="message-body">
	<?php
	if($backup){?>
										<p class="explain" style="text-align:center;">
											<?php
		echo _f('在服务器的<em>%1</em>上有保存的备份文件. 删除插件设定数据后，通过此文件可以复原.',Timestamp::format5($backup));?><br />
												<?php
		echo _t('(在服务器保存的备份文件<a href="#" onclick="downloadBackup();"><font color="#C56D54">开始下载</font></a>)');?>
										</p><br />
	<?php
	}?>

										<div id="admin-password">
											<label for="confirmativePassword"><?php
	echo _t('要删除插件设定数据，输入管理者的密码.');?></label>
											<input type="password" id="confirmativePassword" class="input-text" name="confirmativePassword" onkeydown="if (event.keyCode == 13) { removeData(); return false; }" />
										</div>
									</div>
									<div class="button-box">
										<a class="remove-button button" href="#void" onclick="removeData()"><span class="text"><?php
	echo _t('删除插件设定数据');?></span></a>
										<span class="hidden">|</span>
										<a class="close-button button" href="#void" onclick="hideDialog()" title="<?php
	echo _t('取消命令而关掉此窗口.');?>"><span class="text"><?php
	echo _t('取消');?></span></a>
									</div>
								</form>
							</div>

							<iframe id="blackhole" name="blackhole" style="display: none;"></iframe>
						</div>
	<?php
}

function forceCheckBlog($passFunction){
	global $checkFunction;
	if(!isset($checkFunction))
		return $passFunction;
	return $checkFunction;
}

function getRespondResultPage($error){
	if($error===true)
		$error=0;
	elseif($error===false)
		$error=1;
	print ("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<response>\n<error>$error</error>\n</response>");
	exit;
}

function getPluginServerBackup(){
	global $owner;
	if(!empty($_SESSION['userid']) || ($_SESSION['userid'] == $owner)){
		header('Content-Type: text/xml; charset=UTF-8');
		requireComponent('Eolin.PHP.OutputWriter');
		requireComponent('Tattertools.Data.PluginSetting');

		set_time_limit(0);
		$writer=new OutputWriter();
		{
			if(!file_exists(ROOT.'/cache/backup')){
				mkdir(ROOT.'/cache/backup');
				@chmod(ROOT.'/cache/backup',0777);
			}
			if(!is_dir(ROOT.'/cache/backup')){
				exit;
			}
			if($writer->openFile(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml")){
			}else{
				exit;
			}
		}

		$writer->write('<?xml version="1.0" encoding="utf-8" ?>'.CRLF);
		$writer->write('<blog type="tattertools/1.1" migrational="false">'.CRLF);

		$setting=new PluginSetting();
		if($setting->open()){
			do{
				$writer->write('	<plugin>'.'<name>'.$setting->name.'</name>'.'<setting>'.htmlspecialchars($setting->setting).'</setting>'.'</plugin>');
				$writer->write(CRLF);
			}while($setting->shift());
			$setting->close();
		}
		$writer->write('</blog>');
		$writer->close();
		{
			@chmod(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml",0666);
			getRespondResultPage(0);
		}
	}
}

function getPluginRemove(){
	global $owner, $database;
	if(!empty($_SESSION['userid']) || ($_SESSION['userid'] == $owner)){
		header('Content-Type: text/xml; charset=utf-8');
		requireComponent('Tattertools.Core');
		requireComponent('Tattertools.Data.DataMaintenance');
		if(empty($_POST['confirmativePassword'])||!User::confirmPassword($_POST['confirmativePassword']))
			getRespondResultPage(1);
		mysql_query("DELETE FROM {$database['prefix']}Plugins WHERE owner = $owner");
		getRespondResultPage(0);
	}
}
function getPluginExportBackup(){
	global $owner;
	requireComponent('Eolin.PHP.OutputWriter');
	requireComponent('Tattertools.Data.PluginSetting');
	if(!empty($_SESSION['userid']) || ($_SESSION['userid'] == $owner)){
		set_time_limit(0);
		$writer=new OutputWriter();
		{
			if($writer->openStdout()){
				header('Content-Disposition: attachment; filename="Tattertools-Plugins-Setting-Backup-'.Timestamp::getDate().'.xml"');
				header('Content-Description: Tattertools Backup Data');
				header('Content-Transfer-Encoding: binary');
				header('Content-Type: application/xml');
			}else{
				exit;
			}
		}

		$writer->write('<?xml version="1.0" encoding="utf-8" ?>'.CRLF);
		$writer->write('<blog type="tattertools/1.1" migrational="false">'.CRLF);

		$setting=new PluginSetting();
		if($setting->open()){
			do{
				$writer->write('	<plugin>'.'<name>'.$setting->name.'</name>'.'<setting>'.htmlspecialchars($setting->setting).'</setting>'.'</plugin>');
				$writer->write(CRLF);
			}while($setting->shift());
			$setting->close();
		}

		$writer->write('</blog>');
		$writer->close();
	}
}

function getPluginDownloadBackup(){
	global $owner;
	if(!empty($_SESSION['userid']) || ($_SESSION['userid'] == $owner)){
		if(file_exists(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml")){
			header('Content-Disposition: attachment; filename="Tattertools-Plugins-Setting-Backup-'.Timestamp::getDate(filemtime(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml")).'.xml"');
			header('Content-Description: Tattertools Backup Data');
			header('Content-Transfer-Encoding: binary');
			header('Content-Type: application/xml');
			readfile(ROOT."/cache/backup/{$owner}_plugins_set_backup.xml");
		}else{
			respondNotFoundPage();
		}
	}
}

function getPluginImport(){
	global $owner;
//	if(!empty($_SESSION['userid']) || ($_SESSION['userid'] == $owner)){
		require_once('import/index.php');
//	}
}


function getNumericValuePlugin($value){
	$value=trim($value);
	switch(strtoupper($value{strlen($value)-1})){
		case 'G':
			$value*=1024;
		case 'M':
			$value*=1024;
		case 'K':
			$value*=1024;
	}
	return $value;
}
?>